import 'user.dart';
import 'device.dart';
import 'vasat_model.dart';

class Session extends VasatModel<Session> {

  String? token;
  String? tokenType;
  int? expiry;
  User? user;
  Device? device;

  Session({Map<String, dynamic>? json}) {
    fromJson(json);
  }

  factory Session.fromJson(Map<String, dynamic> json) {
    return Session(json:json);
  }

  @override
  Map<String, dynamic> toJson() {
    var json = <String, dynamic>{
      "access_token": token,
      "token_type": tokenType,
      "expires_in": expiry.toString()
    };
    // Check if we have user to add it
    if (user != null) {
      json["user"] = user!.toJson();
    }
    // Check if we have device to add it
    if (device != null) {
      json["device"] = device!.toJson();
    }
    return json;
  }

  @override
  fromJson(Map<String, dynamic>? json) {
    if (json != null) {
      token = json['access_token'];
      tokenType = json['token_type'];
      if (json['expires_in'] is int) {
        expiry = json['expires_in'];
      } else {
        expiry = int.parse(json['expires_in'].toString());
      }

      // check if user
      if (json.containsKey("user")) {
        user = User.fromJson(json["user"]);
      }
      // check if device
      if (json.containsKey("device")) {
        device = Device.fromJson(json["device"]);
      }
    }
  }

  @override
  Session copyFromJson(Map<String, dynamic> json) {
    return Session.fromJson(json);
  }

}