abstract class VasatModel<T> {

  int? id;
  String? name;
  String? desc;
  bool active = true;
  int? dateMade;
  int? dateUpdated;


  VasatModel({Map<String, dynamic>? json}) {
    fromJson(json);
  }

  fromJson(Map<String, dynamic>? json) {
    if (json != null) {
      id = json['id'];
      name = json['name'];
      desc = json['desc'];
      active = json['active'];
      dateMade = json['dateMade'];
      dateUpdated = json['dateUpdated'];
    }
  }

  Map<String, dynamic> toJson() {
    return {
      "id": id,
      "name": name,
      "desc": desc,
      "active": active,
      "dateMade": dateMade,
      "dateUpdated": dateUpdated
    };
  }

  /// This is so we can dynamically create objects from generic types. DART does not support generic constructor so we do this.
  T copyFromJson(Map<String, dynamic> json);
}